/***********************************************************************************************************************
 * @package		Learning
 * @author		Zahirul Hasan<info@zbabu.com>
 * @copyright	Copyright (c) 2011 - 2019 @ Zahirul Hasan (http://zbabu.com) All rights reserved.
 * @license		http://zbabu.com/license-agreement
 **********************************************************************************************************************/

#caret-down() {
	border-top: @caret-width solid;
	border-right: @caret-width solid transparent;
	border-bottom: 0;
	border-left: @caret-width solid transparent;
}

#caret-up() {
	border-top: 0;
	border-right: @caret-width solid transparent;
	border-bottom: @caret-width solid;
	border-left: @caret-width solid transparent;
}

#caret-right() {
	border-top: @caret-width solid transparent;
	border-right: 0;
	border-bottom: @caret-width solid transparent;
	border-left: @caret-width solid;
}

#caret-left() {
	border-top: @caret-width solid transparent;
	border-right: @caret-width solid;
	border-bottom: @caret-width solid transparent;
}

#caret(@direction: down) {
	& when (@enable-caret) {
		&::after {
			display: inline-block;
			width: 0;
			height: 0;
			margin-left: (@caret-width * 0.85);
			vertical-align: (@caret-width * 0.85);
			content: "";
			& when (@direction = down) {
				#caret-down();
			}
			& when (@direction = up) {
				#caret-up();
			}
			& when (@direction = right) {
				#caret-right();
			}
		}

		& when (@direction = left) {
			&::after {
				display: none;
			}

			&::before {
				display: inline-block;
				width: 0;
				height: 0;
				margin-right: (@caret-width * 0.85);
				vertical-align: (@caret-width * 0.85);
				content: "";
				#caret-left();
			}
		}

		&:empty::after {
			margin-left: 0;
		}
	}
}
